{********************************************************************
*                      ZELJUS szd                                   *
*                    www.zeljus.com                                 *
*                 Email: cvzeljko@gmail.com                         *
*                       2015                                        *
********************************************************************}

unit mainPostClient;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, SynEdit, SynHighlighterXML, SynCompletion,
  SynHighlighterPas, IdHTTP, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

const
  count = 10;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    cbSoapAction: TComboBox;
    eUrl: TEdit;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    lSOAPAction: TLabel;
    lURL: TLabel;
    SynEdit2: TMemo;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    SynCompletion1: TSynCompletion;
    SynEdit1: TSynEdit;
    SynXMLSyn1: TSynXMLSyn;
    procedure Button1Click(Sender: TObject);
    procedure cbSoapActionChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure StaticText1Click(Sender: TObject);
  private
    { private declarations }
    urlGepir: array[0..10] of TStrings;
    procedure Init;
    Procedure Close;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses lclintf;

{ TForm1 }

procedure TForm1.cbSoapActionChange(Sender: TObject);
begin
  SynEdit1.text :=urlGepir[cbSoapAction.ItemIndex].Text;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Init;
end;

procedure TForm1.StaticText1Click(Sender: TObject);
begin
 // OpenURL('http://www.zeljus.com');
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 postData : TMemoryStream;
 IdHTTPPost: TIdHTTP;
begin
   SynEdit2.Clear;
   postData := TMemoryStream.Create;
   SynEdit1.Lines.SaveToStream(postData);
    IdHTTPPost:= TIdHTTP.Create;
 try
    // fill postData with SOAP 1.1 xml as needed...
    IdHTTPPost.Request.ContentType := 'text/xml';
    IdHTTPPost.Request.Charset := 'utf-8';
    IdHTTPPost.Request.CustomHeaders.Values['SOAPAction'] := cbSoapAction.Text;
    try
      SynEdit2.Lines.Text := IdHTTPPost.post(eUrl.Text,  postData);
    except
      ShowMessage('Error!');
    end;
  finally
    postData.Free;
     IdHTTPPost.Free;
  end;
end;

procedure TForm1.Init;
var
  i: integer;
begin
  for i:=0 to count do
     urlGepir[i] := TStringList.Create;

    urlGepir[0].Add('<?xml version="1.0" encoding="utf-8"?>');
    urlGepir[0].Add('<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">');
    urlGepir[0].Add('  <soap:Body>');
    urlGepir[0].Add('    <GetCitiesByCountry xmlns="http://www.webserviceX.NET">');
    urlGepir[0].Add('      <CountryName>Greece</CountryName>');
    urlGepir[0].Add('    </GetCitiesByCountry>');
    urlGepir[0].Add('  </soap:Body>');
    urlGepir[0].Add('</soap:Envelope>');

end;


procedure TForm1.Close;
var
 i: integer;
begin
  for i:=0 to count do
    urlGepir[i].Free;
end;

end.

